﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.Collections.ObjectModel;
using System.Diagnostics;

namespace Sample
{
    public partial class Form1 : Form
    {
        ManagedProj4Projection _proj = null;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadDefaultMap();
            Stopwatch timer = Stopwatch.StartNew();
            LoadTerrain();

            //wfMap.CurrentExtent = _proj.ConvertToExternalProjection(new RectangleShape(-130, 60, 130, -60));
            wfMap.CurrentExtent = _proj.ConvertToExternalProjection(new RectangleShape(49, 37, 101, 19));
            wfMap.Refresh();

            timer.Stop();
            TimeSpan timespan = timer.Elapsed;
            MessageBox.Show(String.Format("{0:00}m:{1:00}s:{2:00}ms", timespan.Minutes, timespan.Seconds, timespan.Milliseconds / 10));
        }

        private void LoadTerrain()
        {
            try
            {
                #region MultipleShapeFileFeatureLayer (13 sec) (9.0.0.1106)
                //Collection<string> colls1 = new Collection<string>();
                //colls1.Add(Application.StartupPath + @"\Data\1000\19N-37N-049E-066E.shp");
                //colls1.Add(Application.StartupPath + @"\Data\1000\19N-37N-066E-084E.shp");
                //colls1.Add(Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.shp");

                //Collection<string> colls2 = new Collection<string>();
                //colls2.Add(Application.StartupPath + @"\Data\1000\19N-37N-049E-066E.midx");
                //colls2.Add(Application.StartupPath + @"\Data\1000\19N-37N-066E-084E.midx");
                //colls2.Add(Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.midx");

                ////string[] colls1 = { Application.StartupPath + @"\Data\1000\19N-37N-049E-066E.shp", Application.StartupPath + @"\Data\1000\19N-37N-066E-084E.shp", Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.shp" };
                ////string[] colls2 = { Application.StartupPath + @"\Data\1000\19N-37N-049E-066E.midx", Application.StartupPath + @"\Data\1000\19N-37N-066E-084E.midx", Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.midx" };
                //MultipleShapeFileFeatureLayer mulShp = new MultipleShapeFileFeatureLayer(colls1, colls2);
                ////MultipleShapeFileFeatureLayer.BuildIndex(Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.shp", Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.midx");
                ////MultipleShapeFileFeatureLayer.BuildIndex(colls1, colls2, BuildIndexMode.Rebuild);
                //mulShp.FeatureSource.Projection = _proj;
                //mulShp.Transparency = 100;
                //mulShp.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColors.Black, (float)0.05));
                //mulShp.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                //LayerOverlay thousandverlay = new LayerOverlay();
                ////thousandverlay.TileCache = new FileBitmapTileCache(@Application.StartupPath + "\\GISCache", "1000Overlay");
                //thousandverlay.Layers.Add("1000_Layer1", mulShp);
                //wfMap.Overlays.Add("1000Overlay", thousandverlay);
                #endregion

                #region ShapeFileFeatureLayer (11 sec) (9.0.0.1106)
                ShapeFileFeatureLayer thousand1 = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\1000\19N-37N-049E-066E.shp", Application.StartupPath + @"\Data\1000\19N-37N-049E-066E.idx", ShapeFileReadWriteMode.ReadOnly);
                thousand1.FeatureSource.Projection = _proj;
                thousand1.Transparency = 100;
                thousand1.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColors.Black, (float)0.05));
                thousand1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                ShapeFileFeatureLayer thousand2 = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\1000\19N-37N-066E-084E.shp", Application.StartupPath + @"\Data\1000\19N-37N-066E-084E.idx", ShapeFileReadWriteMode.ReadOnly);
                thousand2.FeatureSource.Projection = _proj;
                thousand2.Transparency = 100;
                thousand2.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColors.Black, (float)0.05));
                thousand2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                ShapeFileFeatureLayer thousand3 = new ShapeFileFeatureLayer(Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.shp", Application.StartupPath + @"\Data\1000\19N-37N-084E-101E.idx", ShapeFileReadWriteMode.ReadOnly);
                thousand3.FeatureSource.Projection = _proj;
                thousand3.Transparency = 100;
                thousand3.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColors.Black, (float)0.05));
                thousand3.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                LayerOverlay thousandverlay = new LayerOverlay();
                //thousandverlay.TileCache = new FileBitmapTileCache(@Application.StartupPath + "\\GISCache", "1000Overlay");
                thousandverlay.Layers.Add("1000_Layer1", thousand1);
                thousandverlay.Layers.Add("1000_Layer2", thousand2);
                thousandverlay.Layers.Add("1000_Layer3", thousand3);
                wfMap.Overlays.Add("1000Overlay", thousandverlay);
                #endregion
            }
            catch (Exception)
            {
            }
        }

        private void LoadDefaultMap()
        {
            try
            {
                _proj = new ManagedProj4Projection();
                _proj.InternalProjectionParametersString = ManagedProj4Projection.GetEpsgParametersString(4326);
                _proj.ExternalProjectionParametersString = ManagedProj4Projection.GetEsriParametersString(54004);
                _proj.Open();
                wfMap.MapUnit = _proj.GetExternalGeographyUnit();
                wfMap.ExtentOverlay.MouseWheelMode = MapMouseWheelMode.Disabled;
                wfMap.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 200, 227, 255));

                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(Application.StartupPath + @"/Data/Countries02.shp");
                worldLayer.FeatureSource.Projection = _proj;
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.FromArgb(255, 128, 128, 64), 1F), new GeoSolidBrush(GeoColor.FromArgb(255, 239, 228, 176)));
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                LayerOverlay worldOverlay = new LayerOverlay();
                worldOverlay.Layers.Add("WorldLayer", worldLayer);
                wfMap.Overlays.Add("WorldOverlay", worldOverlay);
            }
            catch (Exception err)
            {
                MessageBox.Show(err.Message);
            }
        }
    }
}
